

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">

  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title>Runtime Keystore TISCI Description &mdash; TISCI User Guide</title>




    <link rel="shortcut icon" href="../../_static/favicon.ico"/>












    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />



    <link rel="stylesheet" href="../../_static/theme_overrides.css" type="text/css" />



        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../../index.html"/>
        <link rel="up" title="Chapter 2: TISCI Message Documentation" href="../index.html"/>
        <link rel="next" title="Asymmetric Key Services TISCI Description" href="asymmetric_key_services.html"/>
        <link rel="prev" title="Random Number Generator API" href="rng_api.html"/>


  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">


    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">



            <a href="../../index.html" class="icon icon-home"> TISCI



          </a>




              <div class="version">
                19.07.00
              </div>




<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>


        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">



                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Chapter 2: TISCI Message Documentation</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../index.html#general">General</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#power-management-pm">Power Management (PM)</a></li>
<li class="toctree-l2"><a class="reference internal" href="../index.html#resource-management-rm">Resource Management (RM)</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../index.html#secure-management">Secure Management</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="sec_cert_format.html">Security X509 Certificate Documentation</a></li>
<li class="toctree-l3"><a class="reference internal" href="PROC_BOOT.html">Processor Boot Management TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="firewall_api.html">Firewall TISCI Description</a></li>
<li class="toctree-l3"><a class="reference internal" href="sec_ap_data_transfer.html">Secure AP Command Interface</a></li>
<li class="toctree-l3"><a class="reference internal" href="rng_api.html">Random Number Generator API</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Runtime Keystore TISCI Description</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="asymmetric_key_services.html">Asymmetric Key Services TISCI Description</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../6_topic_user_guides/index.html">Chapter 6: Topic User Guides</a></li>
</ul>



        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">


      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../index.html">TISCI</a>
      </nav>



      <div class="wy-nav-content">
        <div class="rst-content">






<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../index.html">Docs</a> &raquo;</li>

          <li><a href="../index.html">Chapter 2: TISCI Message Documentation</a> &raquo;</li>

    <li>Runtime Keystore TISCI Description</li>
      <li class="wy-breadcrumbs-aside">



      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">

  <div class="section" id="runtime-keystore-tisci-description">
<h1>Runtime Keystore TISCI Description<a class="headerlink" href="#runtime-keystore-tisci-description" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<span id="sec-keystore-tisci-desc"></span><h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This section describes the APIs available to manage the Runtime Keystore in
System Firmware.</p>
<table border="1" class="docutils">
<colgroup>
<col width="19%" />
<col width="81%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">TISCI Message ID</th>
<th class="head">Message Name</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>0x900D</td>
<td><a class="reference internal" href="#keystore-write"><span class="std std-ref">TISCI_MSG_KEYSTORE_WRITE</span></a></td>
</tr>
<tr class="row-odd"><td>0x900E</td>
<td><a class="reference internal" href="#keystore-export"><span class="std std-ref">TISCI_MSG_KEYSTORE_EXPORT_ALL</span></a></td>
</tr>
<tr class="row-even"><td>0x900F</td>
<td><a class="reference internal" href="#keystore-import"><span class="std std-ref">TISCI_MSG_KEYSTORE_IMPORT_ALL</span></a></td>
</tr>
<tr class="row-odd"><td>0x9016</td>
<td><a class="reference internal" href="#keystore-gen-skey-from-rng"><span class="std std-ref">TISCI_MSG_KEYSTORE_GEN_SKEY_FROM_RNG</span></a></td>
</tr>
</tbody>
</table>
<div class="section" id="tisci-msg-keystore-write-write-the-entire-keystore-contents">
<span id="keystore-write"></span><h3>TISCI_MSG_KEYSTORE_WRITE - Write the entire keystore contents<a class="headerlink" href="#tisci-msg-keystore-write-write-the-entire-keystore-contents" title="Permalink to this headline">¶</a></h3>
<p>Keystore write allows the system designer to perform initial provisioning of
keystore contents. This is the foundational keystore operation required by
System Firmware in order to use any subsequent keystore or key service API.</p>
<p>The initial keys are generated off-line, packed into the defined keystore
structure, and signed/encrypted with the active MPK/MEK. For details on the
structure contents and how to sign/encrypt, please refer to <a class="reference internal" href="../../6_topic_user_guides/keystore_provision.html#pub-keystore-provision"><span class="std std-ref">Keystore
Provisioning</span></a>.</p>
<div class="section" id="usage">
<h4>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Secure</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="tisci-message-id">
<h4>TISCI Message ID<a class="headerlink" href="#tisci-message-id" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_KEYSTORE_WRITE</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x900DU)</span></code></p>
<p>Message to write partitioning data and provisioned keys to the keystore
 memory</p>
</p>
<p><p><strong>struct tisci_msg_keystore_write_req</strong></p>
<p>Request for writing the entire keystore contents</p>
<table border="1" class="docutils">
<colgroup>
<col width="12%" />
<col width="19%" />
<col width="69%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Common TI-SCI header</td>
</tr>
<tr class="row-odd"><td>keystore_lo</td>
<td>u32</td>
<td>Lower 32-bit memory location of the signed and encrypted keystore contents</td>
</tr>
<tr class="row-even"><td>keystore_hi</td>
<td>u32</td>
<td>Higher 32-bit memory location of the signed and encrypted keystore contents</td>
</tr>
</tbody>
</table>
<p>A user may unlock the keystore to write its contents using a signed and
 encrypted keystore structure. This operation is required for keystore
 initialization and is mandatorily the first keystore operation which must be
 executed in order to put the keystore in a valid state for subsequent
 operations.</p>
</p>
<p><p><strong>struct tisci_msg_keystore_write_resp</strong></p>
<p>Response to the keystore write</p>
<table border="1" class="docutils">
<colgroup>
<col width="4%" />
<col width="7%" />
<col width="89%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header. ACK response indicates that the accompanying certificate was validated and the keystore contents were successfully decrypted, authenticated, and copied to the internal keystore memory. NACK response indicates that the keystore write could not be completed.</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
<div class="section" id="tisci-msg-keystore-export-all-encrypt-and-export-the-contents-of-the-keystore">
<span id="keystore-export"></span><h3>TISCI_MSG_KEYSTORE_EXPORT_ALL - Encrypt and export the contents of the keystore<a class="headerlink" href="#tisci-msg-keystore-export-all-encrypt-and-export-the-contents-of-the-keystore" title="Permalink to this headline">¶</a></h3>
<div class="section" id="id1">
<h4>Usage<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Secure</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id2">
<h4>TISCI Message ID<a class="headerlink" href="#id2" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_KEYSTORE_EXPORT_ALL</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x900EU)</span></code></p>
<p>Message to encrypt and export the full keystore contents for saving to
 external storage</p>
</p>
<p><p><strong>struct tisci_msg_keystore_export_req</strong></p>
<p>Request for exporting the entire keystore contents</p>
<table border="1" class="docutils">
<colgroup>
<col width="9%" />
<col width="15%" />
<col width="76%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Common TI-SCI header</td>
</tr>
<tr class="row-odd"><td>keystore_lo</td>
<td>u32</td>
<td>Lower 32-bit memory location where the encrypted keystore contents will be placed to pass back to the host</td>
</tr>
<tr class="row-even"><td>keystore_hi</td>
<td>u32</td>
<td>Higher 32-bit memory location where the encrypted keystore contents will be placed to pass back to the host</td>
</tr>
</tbody>
</table>
<p>The host will make the request to encrypt and export the entire keystore
 contents for saving to some storage mechanism to be made available for
 future re-import. Only the host who owns the keystore structure may execute
 this operation. The host is responsible for pre-allocating enough memory to
 fit the keystore structure and all encryption parameters.</p>
</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last"><strong>Subject to change</strong>: Keystore export requires the host allocate <strong>9984</strong>
bytes (0x2700) for System Firmware to copy encrypted contents into.</p>
</div>
<p><p><strong>struct tisci_msg_keystore_export_resp</strong></p>
<p>Response to the keystore export</p>
<table border="1" class="docutils">
<colgroup>
<col width="5%" />
<col width="9%" />
<col width="86%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header. ACK response indicates that the keystore has been encrypted and copied into the host-provided memory. NACK response indicates that the keystore export could not be completed</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
<div class="section" id="tisci-msg-keystore-import-all-import-and-decrypt-a-previously-exported-keystore">
<span id="keystore-import"></span><h3>TISCI_MSG_KEYSTORE_IMPORT_ALL - Import and decrypt a previously exported keystore<a class="headerlink" href="#tisci-msg-keystore-import-all-import-and-decrypt-a-previously-exported-keystore" title="Permalink to this headline">¶</a></h3>
<div class="section" id="id3">
<h4>Usage<a class="headerlink" href="#id3" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Secure</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id4">
<h4>TISCI Message ID<a class="headerlink" href="#id4" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_KEYSTORE_IMPORT_ALL</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x900FU)</span></code></p>
<p>Message to import and decrypt a previously exported keystore blob</p>
</p>
<p><p><strong>struct tisci_msg_keystore_import_req</strong></p>
<p>Request for importing a previously exported keystore</p>
<table border="1" class="docutils">
<colgroup>
<col width="11%" />
<col width="17%" />
<col width="72%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Common TI-SCI header</td>
</tr>
<tr class="row-odd"><td>keystore_lo</td>
<td>u32</td>
<td>Lower 32-bit memory location of the encrypted keystore contents provided by the host</td>
</tr>
<tr class="row-even"><td>keystore_hi</td>
<td>u32</td>
<td>Higher 32-bit memory location of the encrypted keystore contents provided by the host</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_keystore_import_resp</strong></p>
<p>Response to the keystore import</p>
<table border="1" class="docutils">
<colgroup>
<col width="5%" />
<col width="9%" />
<col width="86%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header. ACK response indicates that the imported keystore has been successfully decrypted and authenticated. NACK response indicates that the keystore import could not be completed.</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
<div class="section" id="tisci-msg-keystore-gen-skey-from-rng-generate-a-symmetric-key-from-rng-and-import-it-into-keystore">
<span id="keystore-gen-skey-from-rng"></span><h3>TISCI_MSG_KEYSTORE_GEN_SKEY_FROM_RNG - Generate a symmetric key from RNG and import it into keystore<a class="headerlink" href="#tisci-msg-keystore-gen-skey-from-rng-generate-a-symmetric-key-from-rng-and-import-it-into-keystore" title="Permalink to this headline">¶</a></h3>
<div class="section" id="id5">
<h4>Usage<a class="headerlink" href="#id5" title="Permalink to this headline">¶</a></h4>
<table border="1" class="docutils">
<colgroup>
<col width="75%" />
<col width="25%" />
</colgroup>
<tbody valign="top">
<tr class="row-odd"><td><strong>Message Type</strong></td>
<td>Secure</td>
</tr>
<tr class="row-even"><td><strong>Secure Queue Only?</strong></td>
<td>Yes</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="id6">
<h4>TISCI Message ID<a class="headerlink" href="#id6" title="Permalink to this headline">¶</a></h4>
<p><p><code class="docutils literal"><span class="pre">TISCI_MSG_KEYSTORE_GEN_SKEY_FROM_RNG</span>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160; <span class="pre">(0x9016U)</span></code></p>
<p>Message to generate a symmetric key via RNG and save it in the runtime keystore</p>
</p>
<p><p><strong>struct tisci_msg_keystore_gen_skey_from_rng_req</strong></p>
<p>Request to generate symmetric key from RNG command</p>
<table border="1" class="docutils">
<colgroup>
<col width="16%" />
<col width="22%" />
<col width="62%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header.</td>
</tr>
<tr class="row-odd"><td>key_index</td>
<td>u8</td>
<td>Index in keystore where the generated key must be stored.</td>
</tr>
<tr class="row-even"><td>key_len_bytes</td>
<td>u8</td>
<td>length of the key in bytes.</td>
</tr>
</tbody>
</table>
</p>
<p><p><strong>struct tisci_msg_keystore_gen_skey_from_rng_resp</strong></p>
<p>Response to generate symmetric key from RNG command</p>
<table border="1" class="docutils">
<colgroup>
<col width="5%" />
<col width="8%" />
<col width="87%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Parameter</th>
<th class="head">Type</th>
<th class="head">Description</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>hdr</td>
<td>struct tisci_header</td>
<td>Generic TISCI message header. ACK response indicates that the symmetric key of requested length has been successfully generated and populated into the keystore. NACK response indicates that the operation could not be completed</td>
</tr>
</tbody>
</table>
</p>
</div>
</div>
</div>
</div>


           </div>
          </div>
          <footer>

    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">

        <a href="asymmetric_key_services.html" class="btn btn-neutral float-right" title="Asymmetric Key Services TISCI Description" accesskey="n">Next <span class="fa fa-arrow-circle-right"></span></a>


        <a href="rng_api.html" class="btn btn-neutral" title="Random Number Generator API" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>

    </div>


  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2019</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div>

</footer>

        </div>
      </div>

    </section>

  </div>





    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'19.07.00',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>





    <script type="text/javascript" src="../../_static/js/theme.js"></script>




  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>


</body>
</html>